package net.mcreator.moremobsmod.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsmod.entity.TigerEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class TigerRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(TigerEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_mod:textures/tiger_new.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer bb_main;
		private final ModelRenderer cube_r1;
		private final ModelRenderer cube_r2;
		private final ModelRenderer cube_r3;
		private final ModelRenderer cube_r4;
		private final ModelRenderer cube_r5;
		private final ModelRenderer cube_r6;
		public Modelcustom_model() {
			textureWidth = 128;
			textureHeight = 128;
			bb_main = new ModelRenderer(this);
			bb_main.setRotationPoint(0.0F, 24.0F, 0.0F);
			bb_main.setTextureOffset(20, 50).addBox(-7.0F, -1.0F, -6.0F, 5.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(20, 65).addBox(-7.0F, -14.0F, -3.0F, 5.0F, 14.0F, 5.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 50).addBox(2.0F, -1.0F, -6.0F, 5.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 65).addBox(2.0F, -14.0F, -3.0F, 5.0F, 14.0F, 5.0F, 0.0F, false);
			bb_main.setTextureOffset(20, 46).addBox(-7.0F, -1.0F, 15.0F, 5.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(58, 58).addBox(-7.0F, -14.0F, 18.0F, 5.0F, 14.0F, 5.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 46).addBox(2.0F, -1.0F, 15.0F, 5.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(38, 46).addBox(2.0F, -14.0F, 18.0F, 5.0F, 14.0F, 5.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-9.0F, -27.0F, -5.0F, 18.0F, 12.0F, 34.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-4.0F, -33.0F, -20.25F, 7.0F, 8.0F, 10.0F, 0.0F, false);
			bb_main.setTextureOffset(58, 46).addBox(-3.0F, -30.5F, -26.0F, 5.0F, 2.0F, 6.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 18).addBox(0.5F, -28.5F, -26.0F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(6, 0).addBox(-2.5F, -28.5F, -26.0F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 6).addBox(0.5F, -28.5F, -23.0F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(5, 5).addBox(-2.5F, -28.5F, -23.0F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 3).addBox(2.0F, -34.0F, -20.0F, 2.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-5.0F, -34.0F, -20.0F, 2.0F, 2.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(6, 3).addBox(0.0F, -25.0F, 29.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cube_r1 = new ModelRenderer(this);
			cube_r1.setRotationPoint(1.0F, -24.0F, 30.0F);
			bb_main.addChild(cube_r1);
			setRotationAngle(cube_r1, -0.829F, 0.0F, 0.0F);
			cube_r1.setTextureOffset(0, 46).addBox(-1.0F, -1.0F, 0.0F, 1.0F, 1.0F, 18.0F, 0.0F, false);
			cube_r2 = new ModelRenderer(this);
			cube_r2.setRotationPoint(-1.5F, -25.5F, -25.75F);
			bb_main.addChild(cube_r2);
			setRotationAngle(cube_r2, 0.3054F, 0.0F, 0.0F);
			cube_r2.setTextureOffset(3, 8).addBox(-1.0F, -1.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cube_r2.setTextureOffset(4, 18).addBox(2.0F, -1.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cube_r3 = new ModelRenderer(this);
			cube_r3.setRotationPoint(0.0F, -30.5F, -23.0F);
			bb_main.addChild(cube_r3);
			setRotationAngle(cube_r3, 0.3054F, 0.0F, 0.0F);
			cube_r3.setTextureOffset(73, 54).addBox(-3.0F, 4.0F, -4.0F, 5.0F, 2.0F, 6.0F, 0.0F, false);
			cube_r4 = new ModelRenderer(this);
			cube_r4.setRotationPoint(2.0F, -27.0F, -11.0F);
			bb_main.addChild(cube_r4);
			setRotationAngle(cube_r4, -0.48F, 0.0F, 0.0F);
			cube_r4.setTextureOffset(0, 18).addBox(-6.0F, -4.0F, -1.0F, 7.0F, 6.0F, 9.0F, 0.0F, false);
			cube_r5 = new ModelRenderer(this);
			cube_r5.setRotationPoint(4.0F, -14.0F, 18.0F);
			bb_main.addChild(cube_r5);
			setRotationAngle(cube_r5, -0.6545F, 0.0F, 0.0F);
			cube_r5.setTextureOffset(70, 0).addBox(-2.0F, -10.0F, 0.0F, 5.0F, 10.0F, 5.0F, 0.0F, false);
			cube_r5.setTextureOffset(70, 15).addBox(-11.0F, -10.0F, 0.0F, 5.0F, 10.0F, 5.0F, 0.0F, false);
			cube_r6 = new ModelRenderer(this);
			cube_r6.setRotationPoint(-5.0F, -14.0F, -3.0F);
			bb_main.addChild(cube_r6);
			setRotationAngle(cube_r6, -0.6545F, 0.0F, 0.0F);
			cube_r6.setTextureOffset(40, 72).addBox(-2.0F, -10.0F, 0.0F, 5.0F, 10.0F, 5.0F, 0.0F, false);
			cube_r6.setTextureOffset(73, 73).addBox(7.0F, -10.0F, 0.0F, 5.0F, 10.0F, 5.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			bb_main.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bb_main.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bb_main.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
