package net.mcreator.moremobsmod.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsmod.entity.AlligaderEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class AlligaderRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(AlligaderEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_mod:textures/alligater.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer bb_main;
		private final ModelRenderer cube_r1;
		private final ModelRenderer cube_r2;
		private final ModelRenderer cube_r3;
		private final ModelRenderer cube_r4;
		public Modelcustom_model() {
			textureWidth = 16;
			textureHeight = 16;
			bb_main = new ModelRenderer(this);
			bb_main.setRotationPoint(0.0F, 24.0F, 0.0F);
			bb_main.setTextureOffset(0, 0).addBox(-3.75F, -7.0F, -11.0F, 4.0F, 3.0F, 10.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-3.75F, -4.0F, -11.0F, 4.0F, 3.0F, 10.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-5.25F, -8.0F, -1.0F, 7.0F, 7.0F, 9.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-5.25F, -8.0F, 8.0F, 7.0F, 7.0F, 13.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-4.75F, -7.5F, 21.0F, 6.0F, 6.0F, 13.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-4.25F, -7.0F, 34.0F, 5.0F, 5.0F, 13.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-3.25F, -6.0F, 47.0F, 3.0F, 3.0F, 13.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -7.0F, 58.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -7.0F, 54.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -7.0F, 50.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.0F, 45.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.0F, 41.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.0F, 37.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.5F, 32.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.5F, 29.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.5F, 25.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -8.5F, 22.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 19.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 15.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 12.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 9.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 6.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-2.25F, -9.0F, 0.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(2.0F, -4.0F, 0.0F, 3.0F, 2.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(2.0F, -4.0F, 15.0F, 3.0F, 2.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-8.0F, -4.0F, 0.0F, 3.0F, 2.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-8.0F, -4.0F, 15.0F, 3.0F, 2.0F, 2.0F, 0.0F, false);
			cube_r1 = new ModelRenderer(this);
			cube_r1.setRotationPoint(-6.0F, -2.0F, 9.0F);
			bb_main.addChild(cube_r1);
			setRotationAngle(cube_r1, 0.0F, 0.0436F, 0.0F);
			cube_r1.setTextureOffset(0, 0).addBox(-2.0F, -2.0F, 0.0F, 2.0F, 2.0F, 6.0F, 0.0F, false);
			cube_r2 = new ModelRenderer(this);
			cube_r2.setRotationPoint(-6.0F, -2.0F, -5.0F);
			bb_main.addChild(cube_r2);
			setRotationAngle(cube_r2, 0.0F, 0.0436F, 0.0F);
			cube_r2.setTextureOffset(0, 0).addBox(-2.0F, -2.0F, 0.0F, 2.0F, 2.0F, 6.0F, 0.0F, false);
			cube_r3 = new ModelRenderer(this);
			cube_r3.setRotationPoint(7.0F, -2.0F, 10.0F);
			bb_main.addChild(cube_r3);
			setRotationAngle(cube_r3, 0.0F, -0.2182F, 0.0F);
			cube_r3.setTextureOffset(0, 0).addBox(-2.0F, -2.0F, 0.0F, 2.0F, 2.0F, 6.0F, 0.0F, false);
			cube_r4 = new ModelRenderer(this);
			cube_r4.setRotationPoint(7.0F, -2.0F, -5.0F);
			bb_main.addChild(cube_r4);
			setRotationAngle(cube_r4, 0.0F, -0.2182F, 0.0F);
			cube_r4.setTextureOffset(0, 0).addBox(-2.0F, -2.0F, 0.0F, 2.0F, 2.0F, 6.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			bb_main.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bb_main.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bb_main.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
