package net.mcreator.moremobsmod.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsmod.entity.BlackBearEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class BlackBearRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(BlackBearEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_mod:textures/black_bear.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer bb_main;
		public Modelcustom_model() {
			textureWidth = 128;
			textureHeight = 128;
			bb_main = new ModelRenderer(this);
			bb_main.setRotationPoint(0.0F, 24.0F, 0.0F);
			bb_main.setTextureOffset(0, 46).addBox(-7.0F, -12.0F, -5.0F, 4.0F, 12.0F, 4.0F, 0.0F, false);
			bb_main.setTextureOffset(42, 42).addBox(2.0F, -12.0F, -5.0F, 4.0F, 12.0F, 4.0F, 0.0F, false);
			bb_main.setTextureOffset(26, 34).addBox(2.0F, -12.0F, 11.0F, 4.0F, 12.0F, 4.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-7.0F, -12.0F, 11.0F, 4.0F, 12.0F, 4.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-7.0F, -22.0F, -7.0F, 13.0F, 10.0F, 24.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 34).addBox(-4.0F, -21.0F, -13.0F, 7.0F, 6.0F, 6.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 16).addBox(-2.75F, -18.0F, -17.0F, 4.0F, 3.0F, 4.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			bb_main.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bb_main.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bb_main.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
